import { isVue3 as y, h as u, computed as A, unref as ze, defineComponent as M, ref as j, watch as Q, onMounted as Be, onBeforeUnmount as Le, Vue2 as Ke, inject as ke, provide as Me } from "vue-demi";
import { createListenerPropsForwarder as q, pick as g, withDefaultProps as H, partition as X, isHandlerKey as qe, normalizeListenerKeys as V, isObject as He, useListeners as Ye, isString as he, mergeProps as R, isFunction as K } from "@visoning/vue-utility";
import { FloatingCreatorProps as je, useManualEffect as Ge, FloatingCreator as Z } from "@visoning/vue-floating-core";
import { InteractorProps as xe, createInteractorForwardContext as Je, useInteractorContext as Qe, Interactor as ee } from "@visoning/vue-floating-interactions";
import { offset as Xe, shift as Ze, flip as et, autoPlacement as tt, arrow as rt } from "@floating-ui/core";
var ot = Object.defineProperty, nt = Object.defineProperties, at = Object.getOwnPropertyDescriptors, te = Object.getOwnPropertySymbols, st = Object.prototype.hasOwnProperty, pt = Object.prototype.propertyIsEnumerable, re = (e, t, r) => t in e ? ot(e, t, { enumerable: !0, configurable: !0, writable: !0, value: r }) : e[t] = r, z = (e, t) => {
  for (var r in t || (t = {}))
    st.call(t, r) && re(e, r, t[r]);
  if (te)
    for (var r of te(t))
      pt.call(t, r) && re(e, r, t[r]);
  return e;
}, lt = (e, t) => nt(e, at(t));
const Ee = q(je, ["onFloatingDataUpdate"]), it = g(je, [
  "placement",
  "strategy",
  "middleware",
  "autoUpdate"
]), ct = g(xe, [
  "interactions",
  "delay",
  "hoverDelay",
  "clickDelay",
  "focusDelay",
  "allowPointerEnterTarget",
  "inactiveWhenClickOutside"
]), ut = lt(z(z(z({}, it), Ee.props), ct), {
  open: Boolean,
  defaultOpen: Boolean,
  disabled: Boolean,
  virtualElement: Object,
  appendTo: {},
  autoUpdateOnClosed: Boolean,
  offset: [Number, Object, Function],
  shift: [Boolean, Object],
  flip: [Boolean, Object],
  autoPlacement: [Boolean, Object],
  gpuAcceleration: Boolean,
  destoryedOnClosed: Boolean,
  floatingProps: Object,
  floatingWrapper: Function,
  popupProps: Object,
  popupWrapper: Function,
  zIndex: Number,
  "onUpdate:open": Function,
  onOpen: Function,
  onClose: Function
}), dt = {
  open: void 0,
  defaultOpen: !1,
  shift: !0,
  appendTo: "viewport"
}, Y = H(ut, dt);
var ft = Object.defineProperty, vt = Object.defineProperties, Pt = Object.getOwnPropertyDescriptors, U = Object.getOwnPropertySymbols, Se = Object.prototype.hasOwnProperty, Ce = Object.prototype.propertyIsEnumerable, oe = (e, t, r) => t in e ? ft(e, t, { enumerable: !0, configurable: !0, writable: !0, value: r }) : e[t] = r, B = (e, t) => {
  for (var r in t || (t = {}))
    Se.call(t, r) && oe(e, r, t[r]);
  if (U)
    for (var r of U(t))
      Ce.call(t, r) && oe(e, r, t[r]);
  return e;
}, _t = (e, t) => vt(e, Pt(t)), Ot = (e, t) => {
  var r = {};
  for (var a in e)
    Se.call(e, a) && t.indexOf(a) < 0 && (r[a] = e[a]);
  if (e != null && U)
    for (var a of U(e))
      t.indexOf(a) < 0 && Ce.call(e, a) && (r[a] = e[a]);
  return r;
};
function W(e, t, r) {
  if (r = Array.isArray(r) ? r : [r], y)
    return u(e, t.data, t.scopedSlots ? _t(B({}, t.scopedSlots), {
      default: (...l) => {
        var O, m;
        return r.concat((m = (O = t.scopedSlots) == null ? void 0 : O.default) == null ? void 0 : m.call(O, ...l));
      }
    }) : r);
  const a = t.data, {
    key: _,
    ref: $,
    class: b,
    style: p,
    scopedSlots: P
  } = a, i = Ot(a, [
    "key",
    "ref",
    "class",
    "style",
    "scopedSlots"
  ]), [x, E] = X(Object.keys(i), (l) => qe(l)), { propKeys: o } = t, [s, d] = X(E, (l) => !(o != null && o.includes(l)));
  return u(e, {
    key: _,
    ref: $,
    class: b,
    style: p,
    props: g(i, d),
    attrs: g(i, s),
    scopedSlots: B(B({}, P), t.scopedSlots),
    on: V(g(i, x))
  }, r);
}
let De, Fe, Ie, k;
try {
  const e = require("vue");
  De = e.Transition, Fe = e.Teleport, Ie = e.vShow, k = e.withDirectives;
} catch {
}
function mt(e) {
  return A(() => {
    const t = ze(e), r = [];
    return t.offset && r.push(Xe(t.offset)), t.shift && r.push(Ze(L(t.shift))), t.flip && r.push(et(L(t.flip))), t.autoPlacement && r.push(tt(L(t.autoPlacement))), r.concat(t.middleware || []);
  });
}
function L(e, t = {}) {
  return He(e) ? e : t;
}
var gt = Object.defineProperty, wt = Object.defineProperties, yt = Object.getOwnPropertyDescriptors, ne = Object.getOwnPropertySymbols, $t = Object.prototype.hasOwnProperty, bt = Object.prototype.propertyIsEnumerable, ae = (e, t, r) => t in e ? gt(e, t, { enumerable: !0, configurable: !0, writable: !0, value: r }) : e[t] = r, h = (e, t) => {
  for (var r in t || (t = {}))
    $t.call(t, r) && ae(e, r, t[r]);
  if (ne)
    for (var r of ne(t))
      bt.call(t, r) && ae(e, r, t[r]);
  return e;
}, se = (e, t) => wt(e, yt(t));
const pe = {
  floating: "visoning-floating",
  popup: "visoning-popup"
}, le = M({
  name: "VisoningPopup",
  inheritAttrs: !1,
  props: Y,
  setup(e, { slots: t, attrs: r, expose: a }) {
    const _ = j(!!e.defaultOpen), $ = A(() => e.open === void 0 ? _.value : e.open), b = Ye(), p = (n, v) => {
      _.value = n, n !== e.open && (b.emit("update:open", n, v), b.emit(n ? "open" : "close", v));
    }, P = Je(), i = Qe();
    Q(P, (n) => i == null ? void 0 : i.setInteractor(n));
    const x = A(() => e.virtualElement || P.value), E = j(), o = mt(e), s = A(() => {
      const { appendTo: n } = e;
      return n === !1 ? P.value : he(n) ? document.querySelector(n) : n;
    }), d = j();
    if (!y) {
      const n = () => {
        const { value: w } = s, f = new Ke({
          render() {
            return d.value;
          }
        });
        return f.$mount(), w.appendChild(f.$el), () => {
          var C;
          f.$destroy(), (C = f.$el) == null || C.remove();
        };
      }, { clear: v, reset: c } = Ge(n);
      Q(s, () => c()), Be(c), Le(v);
    }
    const l = j();
    a({
      getElements: () => ({
        floating: E.value,
        reference: P.value
      }),
      updatePosition: () => {
        var n;
        return (n = l.value) == null ? void 0 : n.updatePosition();
      },
      getFloatingData: () => {
        var n;
        return (n = l.value) == null ? void 0 : n.getFloatingData();
      }
    });
    const m = (n) => e.gpuAcceleration ? {
      position: n.strategy,
      top: 0,
      left: 0,
      transform: `translate3d(${n.x}px, ${n.y}px, 0px)`,
      zIndex: e.zIndex
    } : {
      position: n.strategy,
      top: `${n.y}px`,
      left: `${n.x}px`,
      zIndex: e.zIndex
    }, S = (n, v) => {
      let c = W("div", {
        data: R(e.floatingProps, {
          ref: E,
          class: pe.floating,
          style: m(n)
        })
      }, [v]);
      if (e.floatingWrapper && (c = e.floatingWrapper(c)), y)
        return u(Fe, {
          to: s.value
        }, {
          default: () => [c]
        });
      d.value = c;
    }, F = (n) => {
      var v;
      const { value: c } = $, { destoryedOnClosed: w } = e;
      if (!c && w)
        return;
      const f = W("div", {
        data: R(e.popupProps, {
          class: pe.popup
        })
      }, (v = t.default) == null ? void 0 : v.call(t, n));
      if (y)
        k && k(f, [[Ie, c, "show"]]);
      else {
        const C = {
          name: "show",
          value: c
        };
        (f.data.directives || (f.data.directives = [])).push(C);
      }
      return e.popupWrapper ? e.popupWrapper(f) : f;
    }, N = (n) => {
      var v;
      const c = (v = t.reference) == null ? void 0 : v.call(t), w = se(h({}, g(e, Object.keys(xe))), {
        active: $.value
      }), f = {
        "onUpdate:active": p
      };
      return y ? u(ee, h(h(h({}, r), w), f), [c, n]) : u(ee, {
        attrs: r,
        props: w,
        on: V(f)
      }, c);
    };
    return () => {
      const n = e.disabled || !$.value && !e.autoUpdateOnClosed, v = {
        ref: l
      }, c = {
        reference: x.value,
        floating: E.value,
        disabled: n,
        placement: e.placement,
        strategy: e.strategy,
        autoUpdate: e.autoUpdate,
        middleware: o.value
      }, w = Ee.forwards(), f = {
        default: (C) => {
          const Ue = F(C), We = S(C, Ue);
          return N(We);
        }
      };
      return y ? u(Z, h(h(h({}, c), w), v), f) : u(Z, se(h({}, v), {
        props: c,
        on: V(w),
        scopedSlots: f
      }));
    };
  }
}), G = Symbol("ForwardReferenceInjectionKey"), ie = {}, ht = () => {
  const e = ke(G, ie);
  return e === ie ? void 0 : e;
}, nr = () => {
  const e = ht();
  if (!e)
    throw new Error(`injection "${String(G)}" not found; please ensure the component is wrapped in a <Provider>`);
  return e;
}, jt = (e) => {
  Me(G, e);
}, ar = (e) => {
  const t = e || j();
  return jt({
    forwardReference: (r) => t.value = r
  }), t;
};
var xt = Object.defineProperty, Et = Object.defineProperties, St = Object.getOwnPropertyDescriptors, ce = Object.getOwnPropertySymbols, Ct = Object.prototype.hasOwnProperty, Dt = Object.prototype.propertyIsEnumerable, ue = (e, t, r) => t in e ? xt(e, t, { enumerable: !0, configurable: !0, writable: !0, value: r }) : e[t] = r, de = (e, t) => {
  for (var r in t || (t = {}))
    Ct.call(t, r) && ue(e, r, t[r]);
  if (ce)
    for (var r of ce(t))
      Dt.call(t, r) && ue(e, r, t[r]);
  return e;
}, Ft = (e, t) => Et(e, St(t));
const Te = q(Y, ["onFloatingDataUpdate", "onUpdate:open", "onOpen", "onClose"]), Re = g(Y, [
  "placement",
  "strategy",
  "middleware",
  "autoUpdate",
  "interactions",
  "delay",
  "hoverDelay",
  "clickDelay",
  "focusDelay",
  "allowPointerEnterTarget",
  "inactiveWhenClickOutside",
  "open",
  "defaultOpen",
  "disabled",
  "virtualElement",
  "appendTo",
  "autoUpdateOnClosed",
  "offset",
  "shift",
  "flip",
  "autoPlacement",
  "gpuAcceleration",
  "destoryedOnClosed",
  "floatingProps",
  "floatingWrapper",
  "zIndex"
]), It = Ft(de(de({}, Re), Te.props), {
  title: [String, Function],
  content: [String, Function],
  theme: String,
  size: String,
  transitionProps: [String, Object],
  showArrow: Boolean,
  arrow: Function,
  arrowProps: Object,
  popoverProps: Object,
  contentProps: Object,
  popoverWrapper: Function
}), Ne = "visoning-popover", Tt = {
  theme: "line",
  size: "meduim",
  transitionProps: Ne,
  showArrow: !0
}, J = H(It, Tt);
var Rt = Object.defineProperty, Nt = Object.defineProperties, At = Object.getOwnPropertyDescriptors, fe = Object.getOwnPropertySymbols, Vt = Object.prototype.hasOwnProperty, Ut = Object.prototype.propertyIsEnumerable, ve = (e, t, r) => t in e ? Rt(e, t, { enumerable: !0, configurable: !0, writable: !0, value: r }) : e[t] = r, D = (e, t) => {
  for (var r in t || (t = {}))
    Vt.call(t, r) && ve(e, r, t[r]);
  if (fe)
    for (var r of fe(t))
      Ut.call(t, r) && ve(e, r, t[r]);
  return e;
}, Pe = (e, t) => Nt(e, At(t));
const I = {
  popover: "visoning-popover",
  content: "visoning-popover-content",
  title: "visoning-popover-title",
  arrow: "visoning-popover-arrow",
  dark: "theme-dark"
}, _e = M({
  name: "VisoningPopover",
  inheritAttrs: !1,
  props: J,
  setup(e, { attrs: t, expose: r, slots: a }) {
    const _ = j(), $ = ({
      placement: o,
      middlewareData: s
    }) => {
      var d, l, O, m;
      const S = (l = (d = s.arrow) == null ? void 0 : d.y) != null ? l : 0, F = (m = (O = s.arrow) == null ? void 0 : O.x) != null ? m : 0, N = {
        "--vp-arrow-top": `${S}px`,
        "--vp-arrow-left": `${F}px`
      };
      return o.includes("top") || o.includes("bottom") ? N.left = `${F}px` : N.top = `${S}px`, N;
    }, b = (o) => {
      const s = e.arrow || a.arrow;
      return s ? s(o) : u("div", {
        ref: _,
        class: I.arrow,
        style: $(o)
      });
    }, p = A(() => {
      const o = e.middleware || [];
      return e.showArrow && _.value && o.push(rt({
        element: _.value
      })), o;
    }), P = (o) => {
      const { transitionProps: s } = e;
      if (s) {
        const d = he(s) ? { name: s } : D({
          name: Ne
        }, s);
        if (y) {
          const l = o;
          o = u(De, d, {
            default: () => l
          });
        } else
          o = u("transition", {
            props: d
          }, [o]);
      }
      return e.popoverWrapper ? e.popoverWrapper(o) : o;
    }, i = j();
    r({
      updatePosition: () => {
        var o;
        return (o = i.value) == null ? void 0 : o.updatePosition();
      },
      getFloatingData: () => {
        var o;
        return (o = i.value) == null ? void 0 : o.getFloatingData();
      },
      getElements: () => {
        var o;
        return ((o = i.value) == null ? void 0 : o.getElements()) || {};
      }
    });
    const E = (o) => {
      var s, d, l;
      const O = (s = e.title) != null ? s : a.title, m = (l = (d = e.content) != null ? d : a.content) != null ? l : a.default, S = K(O) ? O() : O, F = K(m) ? m() : m;
      return W("div", {
        data: R(e.popoverProps, {
          class: [
            I.popover,
            `size-${e.size}`,
            e.theme === "dark" && I.dark
          ],
          "data-placement": o.placement
        })
      }, [
        W("div", {
          data: R(e.contentProps, {
            class: I.content
          })
        }, [
          S && u("div", {
            class: I.title
          }, [S]),
          F
        ]),
        e.showArrow && b(o)
      ]);
    };
    return () => {
      const o = {
        ref: i
      }, s = Pe(D({}, g(e, Object.keys(Re))), {
        middleware: p.value,
        popupWrapper: P,
        popupProps: R(e.popoverProps, {
          class: I.popover
        })
      }), d = Te.forwards(), l = {
        reference: a.reference,
        default: E
      };
      return y ? u(le, D(D(D(D({}, t), s), d), o), l) : u(le, Pe(D({}, o), {
        props: s,
        on: V(d),
        attrs: t,
        scopedSlots: l
      }));
    };
  }
});
var Wt = Object.defineProperty, zt = Object.defineProperties, Bt = Object.getOwnPropertyDescriptors, Oe = Object.getOwnPropertySymbols, Lt = Object.prototype.hasOwnProperty, Kt = Object.prototype.propertyIsEnumerable, me = (e, t, r) => t in e ? Wt(e, t, { enumerable: !0, configurable: !0, writable: !0, value: r }) : e[t] = r, ge = (e, t) => {
  for (var r in t || (t = {}))
    Lt.call(t, r) && me(e, r, t[r]);
  if (Oe)
    for (var r of Oe(t))
      Kt.call(t, r) && me(e, r, t[r]);
  return e;
}, kt = (e, t) => zt(e, Bt(t));
const Ae = q(J, ["onFloatingDataUpdate", "onUpdate:open", "onOpen", "onClose"]), Ve = g(J, [
  "placement",
  "strategy",
  "middleware",
  "autoUpdate",
  "interactions",
  "delay",
  "hoverDelay",
  "clickDelay",
  "focusDelay",
  "allowPointerEnterTarget",
  "inactiveWhenClickOutside",
  "open",
  "defaultOpen",
  "disabled",
  "virtualElement",
  "appendTo",
  "autoUpdateOnClosed",
  "offset",
  "shift",
  "flip",
  "autoPlacement",
  "gpuAcceleration",
  "destoryedOnClosed",
  "floatingProps",
  "floatingWrapper",
  "zIndex",
  "content",
  "contentProps"
]), Mt = kt(ge(ge({}, Ve), Ae.props), {
  textAlign: String,
  tooltipProps: Object,
  tooltipWrapper: Function
}), qt = {
  interactions: "hover",
  theme: "drak",
  textAlign: "start"
}, Ht = H(Mt, qt);
var Yt = Object.defineProperty, Gt = Object.defineProperties, Jt = Object.getOwnPropertyDescriptors, we = Object.getOwnPropertySymbols, Qt = Object.prototype.hasOwnProperty, Xt = Object.prototype.propertyIsEnumerable, ye = (e, t, r) => t in e ? Yt(e, t, { enumerable: !0, configurable: !0, writable: !0, value: r }) : e[t] = r, T = (e, t) => {
  for (var r in t || (t = {}))
    Qt.call(t, r) && ye(e, r, t[r]);
  if (we)
    for (var r of we(t))
      Xt.call(t, r) && ye(e, r, t[r]);
  return e;
}, $e = (e, t) => Gt(e, Jt(t));
const be = {
  tooltip: "visoning-tooltip",
  content: "visoning-tooltip-content"
}, sr = M({
  name: "Tooltip",
  inheritAttrs: !1,
  props: Ht,
  setup(e, { attrs: t, slots: r, expose: a }) {
    const _ = j();
    a({
      updatePosition: () => {
        var p;
        return (p = _.value) == null ? void 0 : p.updatePosition();
      },
      getFloatingData: () => {
        var p;
        return (p = _.value) == null ? void 0 : p.getFloatingData();
      },
      getElements: () => {
        var p;
        return ((p = _.value) == null ? void 0 : p.getElements()) || {};
      }
    });
    const b = () => {
      var p, P;
      const i = (P = (p = e.content) != null ? p : r.content) != null ? P : r.default;
      return u("div", {
        style: {
          textAlign: e.textAlign
        }
      }, [
        u("span", {
          class: be.content
        }, [K(i) ? i() : i])
      ]);
    };
    return () => {
      const p = {
        ref: _
      }, P = $e(T({}, g(e, Object.keys(Ve))), {
        popoverProps: R(e.tooltipProps, {
          class: be.tooltip
        }),
        popoverWrapper: e.tooltipWrapper
      }), i = Ae.forwards(), x = {
        reference: r.reference,
        arrow: r.arrow,
        content: b
      };
      return y ? u(_e, T(T(T(T({}, t), P), i), p), x) : u(_e, $e(T({}, p), {
        props: P,
        on: V(i),
        attrs: t,
        scopedSlots: x
      }));
    };
  }
});
export {
  _e as Popover,
  I as PopoverClassNames,
  Tt as PopoverDefaultProps,
  J as PopoverProps,
  It as PopoverPropsType,
  Ne as PopoverTransitionName,
  le as Popup,
  dt as PopupDefaultProps,
  Y as PopupProps,
  ut as PopupPropsType,
  sr as Tooltip,
  be as TooltipClassNames,
  qt as TooltipDefaultProps,
  Ht as TooltipProps,
  Mt as TooltipPropsType,
  ar as createReferenceForwardContext,
  jt as providePopupContextValue,
  nr as useReferenceForwardContext,
  ht as useSafeReferenceForwardContent
};
